# Didi Lamken   28.01.2020
# OneWire-Pin   P11 = BOB-HAT-Vx
# Library onewire.py und ds18x20.py

print('DS18B20-test1.py')

import time
from machine            import Pin
from sensors.ds18x20    import DS18X20      # Temperatursensor DS18B20
from lib.onewire        import OneWire      # OneWire-Bus
# from lib.onewire_b    import OneWire      # Test mit vielen CRC-Fehlern

counter     = 0                             # Zyklen
errcnt      = 0                             # Counter Error
ds18b20nr   = 6                             # Sensor Nr
rate        = 0                             # Fehler-Rate

""" Init Onewire-Bus und Sensor DS18B20 """
ow      = OneWire(Pin('P11'))
ds18b20 = DS18X20(ow)
roms    = ds18b20.scan()                    # Sensoren scannen

""" Messen in Schleife """
cntmax = 10                                # max. Durchläufe
for counter in range (cntmax):              # Schleife x mal
# while True:                               # Schleife unendlich
    counter = counter + 1
    print( counter, end='. ' )
    print('Werte: ', end=' ')

    ds18b20.convert_temp()                  # Messen starten
    time.sleep_ms(750)                      # warten
    ds18b20nr = 0
    for rom in roms:
        # print(rom)
        ds18b20nr += 1
        try:
            tmp = ds18b20.read_temp(rom)    # Messwerte auslesen
            ds18b20tmp = int(tmp*10)/10     # 1/10 °C
        except:                             # CRC-Fehler
            ds18b20tmp =  9999              # Dummy-Wert
            errcnt += 1
        print(ds18b20tmp, end='  ')
    print(' Sensoren: ', ds18b20nr, end=' ')
    print(' err: ', errcnt, end=' ')
    if errcnt > 0:
        rate = int(counter / errcnt * ds18b20nr)
        print( ' rate: ', rate, end=' ')
    print(' ')
