# Didi Lamken   28.01.2020
# OneWire-Pin   P11 = BOB-HAT-Vx
# Library onewire.py und ds18x20.py
# OLED-Display

print('DS18B20-test2.py')

import  time
from machine         import Pin, I2C
from sensors.ds18x20 import DS18X20         # Temperatursensor DS18B20
from lib.onewire     import OneWire         # OneWire-Bus
# from lib.onewire_b   import OneWire       # Test mit vielen CRC-Fehlern
import sensors.ssd1306                      # 1.3' OLED-Display

""" Variable                                                 """
# index         0     1     2     3     4     5     6       Variable für Temp.Sensor
ds18b20takt = [ 0.0,  0.0,  0.0,  0.0,  0.0,  0.0,  0.0]  # DS18B20 Temp. Aktuell

counter    = 0                              # Zyklen
errcnt     = 0                              # Counter Error
ds18b20nr  = 6                              # Sensor Nr
rate       = 0                              # Fehler-Rate

""" Init Onewire-Bus und Sensor DS18B20 """
ow      = OneWire(Pin('P11'))
ds18b20 = DS18X20(ow)
roms    = ds18b20.scan()                    # Sensoren scannen

print('Messen --> Anfangswerte DS18B20 ',end=' ')
ds18b20.convert_temp()
time.sleep_ms(750)
ds18b20nr = 0
for rom in roms:
    ds18b20nr += 1
    try:
        tmp = ds18b20.read_temp(rom)    # alle Sensoren auslesen
        ds18b20tmp = int(tmp*10)/10     # 1/10 °C
    except:                             # CRC error
        ds18b20tmp =  9999              # Dummy-Wert
        errcnt += 1
    print(ds18b20tmp, end='  ')
print(' ')

print('main   --> init OLED-Display ')
i2c  = I2C(0, I2C.MASTER, pins=('P9', 'P10'))       # I2C-Bus an PyCom FiPy
oled = sensors.ssd1306.SSD1306_I2C(128, 64, i2c)    # x, y, bus
print('           Textausgabe')
oled.fill(0)                                       # alles aus
oled.text("OLED-Display    ", 0,  0)               # Textausgabe
oled.show()

print('Messen --> Dauerschleife ')
cntmax = 10                            # max. Durchläufe
for counter in range (cntmax):          # Schleife x mal
### while True:                           # Schleife unendlich
    counter = counter + 1
    print( counter, end='. ' )
    ds18b20.convert_temp()
    time.sleep_ms(750)
    ds18b20nr = 0
    for rom in roms:
        ds18b20nr += 1
        try:
            tmp = ds18b20.read_temp(rom)    # alle Sensoren auslesen
            ds18b20tmp = int(tmp*10)/10
        except:                             # CRC error
            # print('CRC', end=' ')
            ds18b20tmp =  9999
            errcnt += 1
        ds18b20takt[ds18b20nr] = ds18b20tmp
    """### Ausgabe der Messwerte                                         """
    print('Werte: ', end=' ')
    ds18b20nr = 0
    for rom in roms:
        ds18b20nr += 1
        print(ds18b20takt[ds18b20nr], end=' ')
    print(' Sensoren: ', ds18b20nr, end=' ')
    print(' err: ', errcnt, end=' ')
    # ds18b20nr = 6
    if errcnt > 0:
        rate = int(counter / errcnt * ds18b20nr)
        print( ' rate: ', rate, end=' ')
    print(' ')

    oled.fill(0)                                         # alles aus
    oled.text("cnt:",               0,  0)
    oled.text(str(counter),        35,  0)
    oled.text("err:",               0,  9)
    oled.text(str(errcnt),         35,  9)
    oled.text("->",                60,  9)
    if errcnt > 0:
        oled.text(str(rate),       80,  9)
    oled.text("DS18B20         " ,  0, 36)
    oled.text(str(ds18b20takt[1]),  0, 45)
    oled.text(str(ds18b20takt[2]), 50, 45)
    oled.text(str(ds18b20takt[3]), 95, 45)
    oled.text(str(ds18b20takt[4]),  0, 54)
    oled.text(str(ds18b20takt[5]), 50, 54)
    oled.text(str(ds18b20takt[6]), 95, 54)
    oled.show()                                         # anzeigen
